mod Ex03a logic: 'cl'

incl Mtex

incl Mauxa

loc rem 
  3. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 3.3.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii na 
  notacii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex03*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Square root function.  \end 

fun Sqrt1 'Tex_f1_pa_sqrt'
  Sqrt1(0) = 0
  Sqrt1(x+1) = Sqrt1(x) <- x+1 < Sq(Sqrt1(x)+1)
  Sqrt1(x+1) = Sqrt1(x)+1 <- x+1 >= Sq(Sqrt1(x)+1)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_sqrt1
    Sq Sqrt1(x) <= x & x < Sq(Sqrt1(x)+1)
  \end

thm Spec_sqrt1
  Sq Sqrt1(x) <= x & x < Sq(Sqrt1(x)+1)

rem 
  \para \bf  Square root with assignments.  \end 

fun Sqrt2 'Tex_f1_pa_sqrt'
  Sqrt2(0) = 0
  Sqrt2(x+1) = Sqrt2(x) <- Sqrt2(x) = s & x+1 < Sq(s+1)
  Sqrt2(x+1) = Sqrt2(x)+1 <- Sqrt2(x) = s & x+1 >= Sq(s+1)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_sqrt2
    Sq Sqrt2(x) <= x & x < Sq(Sqrt2(x)+1)
  \end

thm Spec_sqrt2
  Sq Sqrt2(x) <= x & x < Sq(Sqrt2(x)+1)

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Course of values recursive definitions with measure.  \end 

rem 
  \para \bf  Bottom up program for the square root function I.  \end 

fun/2 F3 'Tex_f2_f'
  F3(x,r) = r <- x < Sq(r+1)
  F3(x,r) = F3(x,r+1) <- x >= Sq(r+1)

fun Sqrt3 'Tex_f1_pa_sqrt'
  Sqrt3(x) = F3(x,0)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_sqrt3
    Sq Sqrt3(x) <= x & x < Sq(Sqrt3(x)+1)
  \end

thm Spec_sqrt3
  Sq Sqrt3(x) <= x & x < Sq(Sqrt3(x)+1)

rem 
  \para \bf  Bottom up program for the square root function II.  \end 

fun/3 F4 'Tex_f3_f'
  F4(x,r,s) = r <- s+2*r+1 = s1 & x < s1
  F4(x,r,s) = F4(x,r+1,s1) <- s+2*r+1 = s1 & x >= s1

fun Sqrt4 'Tex_f1_pa_sqrt'
  Sqrt4(x) = F4(x,0,0)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_sqrt4
    Sq Sqrt4(x) <= x & x < Sq(Sqrt4(x)+1)
  \end

thm Spec_sqrt4
  Sq Sqrt4(x) <= x & x < Sq(Sqrt4(x)+1)

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. \ft p \end-ary arithmetic.  \end 

rem 
  \para \bf  A fast program for the square root function.  \end 

fun Sqrt5 'Tex_f1_pa_sqrt'
  Sqrt5(x) = Sgn(z) <- x = 4*y+z & 0 <= z & z <= 3 & y = 0
  Sqrt5(x) = s <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt5(y) = s & x < Sq(s+1)
  Sqrt5(x) = s+1 <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt5(y) = s & x >= Sq(s+1)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_sqrt5
    Sq Sqrt5(x) <= x & x < Sq(Sqrt5(x)+1)
  \end
  \para \it  Hint.  \end See the theorem \ft Pary_case_analysis4 \end in the 
  module \ft Mauxa \end. 

thm Spec_sqrt5
  Sq Sqrt5(x) <= x & x < Sq(Sqrt5(x)+1)

